function Fitness = CalFitness2(PopObj,PopCon)
% Calculate the fitness of each solution for mating selection

    N = size(PopObj,1);
    CV = sum(max(0,PopCon),2);

    %% Detect the dominance relation between each two solutions
    Dominate = false(N);
    for i = 1 : N-1
        for j = i+1 : N
            k = any(PopObj(i,:)<PopObj(j,:)) - any(PopObj(i,:)>PopObj(j,:));
            if k == 1
                Dominate(i,j) = true;
            elseif k == -1
                Dominate(j,i) = true;
            end
        end
    end
    
    %% Calculate S(i)
    S = sum(Dominate,2);
    
    %% Calculate R(i)
    R = zeros(1,N);
    for i = 1 : N
        R(i) = sum(S(Dominate(:,i)));
    end
    
    %% Calculate the fitnesses
    for i=1:N
        if CV(i)==0||R(i)==0
            Fitness(i)=0;
        else
            Fitness(i)=CalFitness(PopObj(i,:),PopCon(i,:));
        end
    end
    %Fitness = R ;
end